
/*
 * $Id: IntvlCut.cc,v 1.1.2.1 1999/07/29 19:04:40 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include "IntvlCut.h"


IntervalCutter::IntervalCutter() {
}

void IntervalCutter::configure(Time anIntvl) {
	Assert(anIntvl != 0);
	theIntvl = anIntvl;
}

bool IntervalCutter::update(Time curTime) {
	Assert(curTime >= 0);

	// if the cutter is disabled, always return true
	if (theIntvl < 0) {
		theEoi = curTime;
		return true;
	}

	if (theEoi < 0)
		theEoi = curTime;
	else
	if (curTime > theEoi + theIntvl) {
		// note: we use (a,b] interval to ensure that
		// if two events happen at the same time, they
		// always end up in the same interval!
		do {
			theEoi += theIntvl;
		} while (curTime >= theEoi + theIntvl);
		return true;
	}

	return false;
}
