
/*
 * $Id: ListenQueue.cc,v 1.2 1999/05/22 03:11:43 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include "Select.h"
#include "ListenQueue.h"


ListenQueue::ListenQueue(): theListener(0), theListFD(-1),
	theAccAvg(0), theReadyCount(0), theAccCount(0) {
}

void ListenQueue::begCycle(int) {
	theReadyCount = 0;
	theAccCount = 0;
}

void ListenQueue::tick() {
	theReadyCount++;
	// have listener && should have accepted < actually accepted
	if (theListener && (theAccAvg * theReadyCount) < theAccCount)
		theListener->noteReadReady(theListFD);
}

void ListenQueue::endCycle() {
	if (theReadyCount) {
		// avg[i] = 0.5*avg[i-1] + (1-0.5)*x[i]
		theAccAvg += theAccCount/(double)theReadyCount;
		theAccAvg /= 2; // hardcoded decay speed (0.5)
	}
}
