
/*
 * $Id: SharedOpts.h,v 1.5.2.3 1999/06/14 21:08:02 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef SHARED_OPTS
#define SHARED_OPTS

#include "opts.h"
#include "polyOpts.h"

// options shared by client and server sides
class SharedOpts: public OptGrp {
	public:
		SharedOpts(); // defaults

		virtual bool validate() const;
		
	public:
		HelpOpt theHelpOpt;
		VersionOpt theVersOpt;
		IntOpt theVerbLevel;
		BoolOpt doPrintReqs;
		BoolOpt doPrintReps;
		NetAddrOpt theMonitor;
		StrOpt theRunLabel;

		IntOpt theFDLimit;

		StrOpt theConsFileName;
		StrOpt theLogFileName;
		SizeOpt theLogSize;

		TimeOpt theLingerTimeout;
		BoolOpt doUseNagle;

		FileScanOpt theFileScanner;

		DistrOpt theXactThinkTime;
		DistrOpt theRdThinkTime;
		DistrOpt theWrThinkTime;

		DistrOpt thePconnUseLmt;

		GoalOpt theGoal;

		IntOpt theRngSeed;
};

extern SharedOpts TheOpts;

#endif
