
/*
 * $Id: shutdown.h,v 1.2 1999/04/15 20:36:16 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef SHUTDOWN_H
#define SHUTDOWN_H

// routines that determine shutdown conditions, report them,
// and assist in nice program termination

class String;

// stop now? (checks various conditions)
extern bool ShutdownNow();

// returns true iff ShutdownNow returned true before
extern bool ShutdownRequested();

// note a shutdown signal
extern void ShutdownSignal(int s);

// specify a mimimal cool-off period
extern void CoolOffTime(Time);

// force a shutdown for some reason
extern void ShutdownReason(const String &reason);

// to be registered with at_exit
extern void Shutdown();

#endif
