
/*
 * $Id: polyVersion.cc,v 1.5.2.4 1999/08/30 18:29:49 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include "String.h"
#include "polyVersion.h"

// sync this and remake executables whenever release name changes!
#define POLY_VERSION_STR "1.3.2"

// for use with ident-like scanners
static String PolyVerIdentStr = 
	"$Polygraph: " POLY_VERSION_STR " $";
static String PolyCompTimestampIdentStr = 
	"$CompilationTimestamp: " __DATE__ " " __TIME__ " $";

const String &PolyVersion() {
	Assert(PolyVerIdentStr); // just to use it somewhere
	Assert(PolyCompTimestampIdentStr); // just to use it somewhere
	static String vs = POLY_VERSION_STR;
	return vs;
}

const String &PolyCompDate() {
	static String ds = __DATE__;
	return ds;
}

const String &PolyCompTime() {
	static String ts = __TIME__;
	return ts;
}

const String &PolyLetterhd() {
	static String lh =
		"Polygraph " POLY_VERSION_STR
		"       Copyright (C) 1998, 1999.\n"
		"Distributed without any warranty, even implied. \n"
		"See  http://polygraph.ircache.net/ for details.";
	return lh;
}
