
/*
 * $Id: NetAddr.cc,v 1.2 1999/04/25 06:32:12 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "xstd.h"

#include <arpa/inet.h>
#include <iostream.h>

#include "NetAddr.h"

void NetAddr::syncA() const {
	theAddrA = inet_ntoa(theAddrN);
}

void NetAddr::syncN() const {
	if (theAddrA)
		theAddrN.s_addr = inet_addr(theAddrA);
	else
		theAddrN.s_addr = INADDR_NONE;
}

bool NetAddr::operator == (const NetAddr &addr) const {
	if (thePort != addr.thePort)
		return false;

	if (theAddrN.s_addr != INADDR_NONE && addr.theAddrN.s_addr != INADDR_NONE)
		return theAddrN.s_addr == addr.theAddrN.s_addr;

	return theAddrA == addr.theAddrA;
}

ostream &NetAddr::print(ostream &os) const {
	if (thePort < 0)
		return os << "<none>";

	if (!theAddrA)
		syncA();

	return os << theAddrA << ':' << thePort;
}
