
/*
 * $Id: fixPoll.h,v 1.1.2.1 1999/06/16 01:59:55 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef XSTD_FIX_POLL_H
#define XSTD_FIX_POLL_H

#ifndef LACK_POLL
#include <poll.h>

/* Linux does not define "NORM" */
#ifndef POLLRDNORM
#define POLLRDNORM POLLIN
#endif
#ifndef POLLWRNORM
#define POLLWRNORM POLLOUT
#endif

inline
int xpoll(pollfd *fds, unsigned int nfds, int timeout) {
	return ::poll(fds, nfds, timeout);
}

#else

#define POLLRDNORM 1
#define POLLWRNORM 2
#define POLLERR 4
#define POLLHUP 8
#define POLLNVAL 16

struct pollfd { int fd;  short events; short revents; };
extern int xpoll(pollfd *fds, unsigned int nfds, int timeout);

#endif /* LACK_POLL */

#endif
